/********************************************************************
*																	*
*		File :		CALC.CPP										*
*		Type :		source											*
*		Version :	1.0												*
*		Date :		24/07/2000										*
*		Author :	Marc MILEUR										*
*																	*
********************************************************************/


#include "espoir.h"


void PosCalc (PROFILEDATA * pProfileData)
{
	DOUBLE		PO, HMIN, TANTH = 0, FWHM = 0, ASTEP ;
	LONG		I = 0 ;

	HMIN = (pProfileData->STEP) * (pProfileData->STEPN) ;
	PO = 0.01 ;
	(pProfileData->POS)[I] = 0.01 ;
	for (I = 1 ; I < (pProfileData->N2) ; I ++)
	{
		TANTH = tan (((pProfileData->POS)[I - 1]) / PI) ;
		FWHM = sqrt (((pProfileData->U) * TANTH * TANTH) + ((pProfileData->V) * TANTH) + (pProfileData->W)) ;
		ASTEP = (pProfileData->STEP) * FWHM / HMIN ;
		PO = PO + ASTEP ;
		if ((PO > 160) && (I < pProfileData->NPTS))
		{
			pProfileData->NPTS = I ;
			break ;
		}
		(pProfileData->POS)[I] = PO ;
	}
}	// PosCalc


INT MaxInArray (INT * array, INT iArrayLenght)
{
	INT		I = 0, MAX ;

	MAX = array[I] ;
	for (I = 1 ; I < iArrayLenght ; I ++)
	{
		if (array[I] > MAX)
			MAX = array[I] ;
	}
	return MAX ;
}	// MaxInArray


INT MinInArray (INT * array, INT iArrayLenght)
{
	INT		I = 0, MIN ;

	MIN = array[I] ;
	for (I = 1 ; I < iArrayLenght ; I ++)
	{
		if (array[I] < MIN)
			MIN = array[I] ;
	}
	return MIN ;
}	// MinInArray
