/********************************************************************
*																	*
*		File :		ESPOIR.H										*
*		Type :		header											*
*		Version :	1.0												*
*		Date :		25/07/2000										*
*		Author :	Marc MILEUR										*
*																	*
********************************************************************/


#include <windows.h>
#include <process.h>
#include <commdlg.h>
#include <math.h>
#include "resource.h"
#include "esptypes.h"


	// constants
#define		PI					114.592
#define		BUFFER_SIZE			512						// string buffer size
#define		ID_FIRST_CHILD		50000					// first child window identifier
#define		IDM_FILE			0						// File submenu position
#define		IDM_EDIT			1						// Edit submenu position
#define		IDM_VIEW			2						// View submenu position
#define		IDM_RUN				3						// Run submenu position
#define		IDM_WINDOW			4						// Window submenu position
#define		IDM_HELP			5						// Help submenu position
#define		WM_INITIALIZE		(WM_USER + 1)		 	// new Windows messages
#define		WM_WRITETEXT		(WM_USER + 2)
#define		WM_TITLE			(WM_USER + 3)
#define		WM_PROGRESS			(WM_USER + 4)


	// functions declarations
extern "C" {	// for FORTRAN compatibility
		// functions in espoir.for
	void WINAPI ESPOIR (PROJECT *, CHAR *, LONG) ;

		// functions in winespoir.cpp
	int WINAPI WinMain (HINSTANCE, HINSTANCE, PSTR, int) ;
	LRESULT CALLBACK FrameWndProc (HWND, UINT, WPARAM, LPARAM) ;
	BOOL CALLBACK AboutDlgProc (HWND, UINT, WPARAM, LPARAM) ;
	LRESULT CALLBACK EditWndProc (HWND, UINT, WPARAM, LPARAM) ;
	LRESULT CALLBACK ProgressWndProc (HWND, UINT, WPARAM, LPARAM) ;
	BOOL WindowClassCreation (HINSTANCE) ;
	void CreateEditWindow (PROJECT *, EDITFILE, HWND) ;
	void CreateProgressWindow (PROJECT *, HWND) ;
	BOOL CreateProfileWindow (PROJECT *, HWND) ;
	void ViewFile (PROJECT *, EDITFILE, HWND) ;
	BOOL ViewProfile (PROJECT *, HWND) ;
	void ViewStructure (PROJECT *, HWND) ;
	DWORD WINAPI EspoirThread (void *) ;
	void WINAPI PROGRESSVIEW (PROJECT *, CHAR *, LONG) ;

		// functions in file.cpp
	void FileInitialize (HWND, OPENFILENAME *, CHAR *, CHAR *) ;
	BOOL FileOpenDlg (OPENFILENAME *) ;
	BOOL FileRead (UINT, HWND, OPENFILENAME *) ;
	BOOL FileWrite (HWND, OPENFILENAME *) ;
	BOOL FileSaveDlg (OPENFILENAME *) ;

		// functions in string.cpp
	LONG SpaceJumping (CHAR *, LONG) ;
	LONG FloatReading (CHAR *, LONG, DOUBLE *) ;
	LONG IntReading (CHAR *, LONG, INT *) ;
	LONG LineJumping (CHAR *, LONG) ;
	LONG NextSpaceJumping (CHAR *, LONG) ;
	LONG IntArrayReading (CHAR *, LONG, INT *, INT) ;
	LONG NextNumberJumping (CHAR *, LONG) ;
	LONG LongArrayReading (CHAR *, LONG, LONG *, INT) ;
	LONG LongReading (CHAR *, LONG, LONG *) ;
	LONG FloatArrayReading (CHAR *, LONG, DOUBLE *, INT) ;

		// functions in calc.cpp
	void PosCalc (PROFILEDATA *) ;
	INT MaxInArray (INT *, INT) ;
	INT MinInArray (INT *, INT) ;
}


