/********************************************************************
*																	*
*		File :		ESPOIRW.CPP										*
*		Type :		source											*
*		Version :	1.0												*
*		Date :		26/07/2000										*
*		Author :	Marc MILEUR										*
*																	*
********************************************************************/


#include "espoir.h"


	// globals
HINSTANCE		hInst ;									// handle to the program
HMENU			hMenu, hMenuWindow ;					// handles to the menu and the Window submenu
BOOL			bRunEspoir ;							// TRUE if ESPOIR is running, FALSE otherwise
LONG			lNbChildWnd ;							// number of child window
CHAR *			szAppName = "Espoir" ;					// application name
CHAR *			szMenuName = "EspoirMenu" ;				// menu name
CHAR *			szFrameWCN = "FrameWndClass" ;			// frame window class name
CHAR *			szEditWCN = "EditWndClass" ;			// edit child window class name
CHAR *			szProgressWCN = "ProgressWndClass" ;	// progress child window class name
CHAR *			szProfileWCN = "ProfileWndClass" ;		// profile child window class name
PRJLIST			lstProject ;							// projects list
CHAR			szBuffer[BUFFER_SIZE] ;					// string buffer
CHAR			szNew[BUFFER_SIZE] ;					// string buffer for new file
BOOL			bExit ;									// boolean used in loops


	// functions

	// main function
int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
{
	HACCEL		hAccel ;				// handle to accelerators table
	HWND		hwndFrame, hwndClient ;	// handles to the frame and the client windows
	MSG			msg ;					// message informations

		// hInstance initialization
	hInst = hInstance ;

		// windows classes creation
	if (!WindowClassCreation (hInstance))
		return 0 ;

		// load the menu
	hMenu = LoadMenu (hInstance, MAKEINTRESOURCE (IDM_MENU)) ;
	hMenuWindow = GetSubMenu (hMenu, IDM_WINDOW) ;

		// load accelerator table
	hAccel = LoadAccelerators (hInstance, MAKEINTRESOURCE (IDA_ACCELERATOR)) ;

		// create the frame window
	hwndFrame = CreateWindow (szFrameWCN, szAppName, WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, hMenu, hInstance, NULL) ;

		// initialize the client window
	hwndClient = GetWindow (hwndFrame, GW_CHILD) ;

		// show the frame window
	ShowWindow (hwndFrame, iCmdShow) ;
	UpdateWindow (hwndFrame) ;

		// message loop
	while (GetMessage (&msg, NULL, 0, 0))
	{
		if (!TranslateMDISysAccel (hwndClient, &msg) && !TranslateAccelerator (hwndFrame, hAccel, &msg))
		{
			TranslateMessage (&msg) ;
			DispatchMessage (&msg) ;
		}
	}

	return msg.wParam ;
}	// WinMain


	// frame window procedure
LRESULT CALLBACK FrameWndProc (HWND hwndFrame, UINT message, WPARAM wParam, LPARAM lParam)
{
	static HWND				hwndClient ;		// handle to the client window
	HWND					hwndChild ;			// handle to child window
	CLIENTCREATESTRUCT		clientcreate ;		// client window creation informations
	PROJECT *				pProject ;			// espoir project informations
	PROJECT *				pPTemp ;
	INT						i ;

		// process messages
	switch (message)
	{
		// frame window creation message
	case WM_CREATE :
		bRunEspoir = FALSE ;
		lNbChildWnd = 0 ;
			// create the client window
		clientcreate.hWindowMenu = hMenu ;
		clientcreate.idFirstChild = ID_FIRST_CHILD ;
		hwndClient = CreateWindow ("MDICLIENT", NULL, WS_CHILD | WS_CLIPCHILDREN | WS_VISIBLE, 0, 0, 0, 0, hwndFrame, hMenu, hInst, (PSTR) &clientcreate) ;
		return 0 ;

		// menu or submenu is about to become active
	case WM_INITMENUPOPUP :
			// update menu
		EnableMenuItem (hMenu, IDM_FILE_SAVE, MF_GRAYED) ;
		EnableMenuItem (hMenu, IDM_FILE_SAVEAS, MF_GRAYED) ;
		EnableMenuItem (hMenu, IDM_FILE_CLOSE, MF_GRAYED) ;
		EnableMenuItem (hMenu, IDM_EDIT_CUT, MF_GRAYED) ;
		EnableMenuItem (hMenu, IDM_EDIT_COPY, MF_GRAYED) ;
		EnableMenuItem (hMenu, IDM_EDIT_PASTE, MF_GRAYED) ;
		EnableMenuItem (hMenu, IDM_VIEW_DAT, MF_GRAYED) ;
		EnableMenuItem (hMenu, IDM_VIEW_HKL, MF_GRAYED) ;
		EnableMenuItem (hMenu, IDM_VIEW_IMP, MF_GRAYED) ;
		EnableMenuItem (hMenu, IDM_VIEW_INS, MF_GRAYED) ;
		EnableMenuItem (hMenu, IDM_VIEW_SPF, MF_GRAYED) ;
		EnableMenuItem (hMenu, IDM_VIEW_PRF, MF_GRAYED) ;
		EnableMenuItem (hMenu, IDM_VIEW_PROFILE, MF_GRAYED) ;
		EnableMenuItem (hMenu, IDM_VIEW_STRUCTURE, MF_GRAYED) ;
		CheckMenuItem (hMenu, IDM_VIEW_DAT, MF_UNCHECKED) ;
		CheckMenuItem (hMenu, IDM_VIEW_HKL, MF_UNCHECKED) ;
		CheckMenuItem (hMenu, IDM_VIEW_IMP, MF_UNCHECKED) ;
		CheckMenuItem (hMenu, IDM_VIEW_INS, MF_UNCHECKED) ;
		CheckMenuItem (hMenu, IDM_VIEW_SPF, MF_UNCHECKED) ;
		CheckMenuItem (hMenu, IDM_VIEW_PRF, MF_UNCHECKED) ;
		CheckMenuItem (hMenu, IDM_VIEW_PROFILE, MF_UNCHECKED) ;
		EnableMenuItem (hMenu, IDM_RUN_ESPOIR, MF_GRAYED) ;
		EnableMenuItem (hMenu, IDM_WINDOW_CLOSEALL, MF_GRAYED) ;
		EnableMenuItem (hMenu, IDM_WINDOW_CASCADE, MF_GRAYED) ;
		EnableMenuItem (hMenu, IDM_WINDOW_TILE, MF_GRAYED) ;
		EnableMenuItem (hMenu, IDM_WINDOW_ARRANGE, MF_GRAYED) ;
		if (hwndChild = GetWindow (hwndClient, GW_CHILD))
			SendMessage (hwndChild, WM_INITMENUPOPUP, wParam, lParam) ;
		return 0 ;

		// commands
	case WM_COMMAND :
		switch (LOWORD (wParam))
		{
		case IDM_FILE_OPEN :
				// create a new project
			pProject = new PROJECT ;
			ProjectInitialize (pProject, hwndFrame) ;
			if (FileOpenDlg ((pProject->pdEditWnd)[dat].pOfn))
			{
				strcpy (pProject->szName, (pProject->pdEditWnd)[dat].pOfn->lpstrFileTitle) ;
				(pProject->szName)[strlen (pProject->szName) - 4] = '\0' ;
				if (!lstProject.exist (pProject->szName))
				{
					lstProject.insert (pProject) ;
					for (i = dat + 1 ; i < NBEDITFILE ; i ++)
					{
						strcpy (szBuffer, (pProject->pdEditWnd)[dat].pOfn->lpstrFileTitle) ;
						szBuffer[strlen (szBuffer) - 3] = '\0' ;
						strcat (szBuffer, (pProject->pdEditWnd)[i].pOfn->lpstrDefExt) ;
						strcpy ((pProject->pdEditWnd)[i].pOfn->lpstrFileTitle, szBuffer) ;
						strcpy (szBuffer, (pProject->pdEditWnd)[dat].pOfn->lpstrFile) ;
						szBuffer[strlen (szBuffer) - 3] = '\0' ;
						strcat (szBuffer, (pProject->pdEditWnd)[i].pOfn->lpstrDefExt) ;
						strcpy ((pProject->pdEditWnd)[i].pOfn->lpstrFile, szBuffer) ;
					}
					CreateEditWindow (pProject, dat, hwndClient) ;
				}
				else
				{
					pPTemp = lstProject.find (pProject->szName) ;
					ProjectDestroy (pProject) ;
					ViewFile (pPTemp, dat, hwndClient) ;
				}
			}
			else
				ProjectDestroy (pProject) ;
			return 0 ;

		case IDM_FILE_CLOSE :
			hwndChild = (HWND) SendMessage (hwndClient, WM_MDIGETACTIVE, 0, 0) ;
			SendMessage (hwndChild, WM_CLOSE, 0, 0) ;
			return 0 ;

		case IDM_FILE_EXIT :
			SendMessage (hwndFrame, WM_CLOSE, 0, 0) ;
			return 0 ;

		case IDM_WINDOW_CLOSEALL :
			while (hwndChild = GetWindow (hwndClient, GW_CHILD))
				SendMessage (hwndChild, WM_CLOSE, 0, 0) ;
			return 0 ;

		case IDM_WINDOW_CASCADE :
			SendMessage (hwndClient, WM_MDICASCADE, 0, 0) ;
			return 0 ;

		case IDM_WINDOW_TILE :
			SendMessage (hwndClient, WM_MDITILE, 0, 0) ;
			return 0 ;

		case IDM_WINDOW_ARRANGE :
			SendMessage (hwndClient, WM_MDIICONARRANGE, 0, 0) ;
			return 0 ;

		case IDM_HELP_HELP :
			WinHelp (hwndFrame, "espoir.hlp", HELP_CONTENTS, 0) ;
			return 0 ;

		case IDM_HELP_ABOUT :
			DialogBox (hInst, MAKEINTRESOURCE (IDD_ABOUT), hwndFrame, AboutDlgProc) ;
			return 0 ;

		default :
			if (hwndChild = (HWND) SendMessage (hwndClient, WM_MDIGETACTIVE, 0, 0))
				SendMessage (hwndChild, WM_COMMAND, wParam, lParam) ;
			break ;
		}
		break ;

		// session ends
	case WM_QUERYENDSESSION :
		
		// application ends
	case WM_CLOSE :
		SendMessage (hwndFrame, WM_COMMAND, IDM_WINDOW_CLOSEALL, 0) ;
		WinHelp (hwndFrame, "espoir.hlp", HELP_QUIT, 0) ;
		break ;

		// window is being destroyed
	case WM_DESTROY :
		PostQuitMessage (0) ;
		return 0 ;
	}

	return DefFrameProc (hwndFrame, hwndClient, message, wParam, lParam) ;
}	// FrameWndProc


	// About dialog box procedure
BOOL CALLBACK AboutDlgProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG :
		return TRUE ;

	case WM_COMMAND :
		switch (LOWORD (wParam))
		{
		case IDD_ABOUT_OK :
			EndDialog (hDlg, 0) ;
			return TRUE ;
		}
		break ;
	}
	return FALSE ;
}	// AboutDlgProc


	// edit child window procedure
LRESULT CALLBACK EditWndProc (HWND hwndEdit, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND			hwndClient, hwndFrame ;		// handles to the client and frame windows
	HWND			hwndText ;					// handles to the text window
	PROJECT *		pProject ;					// pointer to the project data structure
	PROJECT *		pPTemp ;
	EDITDATA *		pEditData ;					// pointer to the edit data structure
	INT				iSelect ;					// selection size
	LONG			lDestroy ;					// project destroying flag
	INT				i ;
	HANDLE			hFile ;						// handle to a file

		// initialize window handles
	hwndClient = GetParent (hwndEdit) ;
	hwndFrame = GetParent (hwndClient) ;
	hwndText = GetWindow (hwndEdit, GW_CHILD) ;

		// initialize window datas
	pProject = (PROJECT *) GetWindowLong (hwndEdit, 0) ;
	pEditData = (EDITDATA *) GetWindowLong (hwndEdit, sizeof (PROJECT *)) ;

		// process messages
	switch (message)
	{
		// edit child window creation message
	case WM_CREATE :
		lNbChildWnd ++ ;
		SetWindowLong (hwndEdit, 0, (LONG) NULL) ;
		SetWindowLong (hwndEdit, sizeof (PROJECT *), (LONG) NULL) ;
			// create text window
		hwndText = CreateWindow ("EDIT", NULL, WS_HSCROLL | WS_VSCROLL | WS_CHILD | WS_VISIBLE | ES_LEFT | ES_MULTILINE | ES_AUTOHSCROLL | ES_AUTOVSCROLL, 0, 0, 0, 0, hwndEdit, (HMENU) lNbChildWnd, hInst, NULL) ;
		return 0 ;

		// window datas initialization
	case WM_INITIALIZE :
		pProject = (PROJECT *) wParam ;
		SetWindowLong (hwndEdit, 0, (LONG) pProject) ;
		pEditData = (EDITDATA *) lParam ;
		SetWindowLong (hwndEdit, sizeof (PROJECT *), (LONG) pEditData) ;
		return 0 ;

		// drop-down menu or submenu is about to become active
	case WM_INITMENUPOPUP :
		if (pEditData->bNeedSave)
			EnableMenuItem (hMenu, IDM_FILE_SAVE, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_FILE_SAVEAS, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_FILE_CLOSE, MF_ENABLED) ;
		iSelect = SendMessage (hwndText, EM_GETSEL, 0, 0) ;
		if (HIWORD (iSelect) != LOWORD (iSelect))
		{
			EnableMenuItem (hMenu, IDM_EDIT_CUT, MF_ENABLED) ;
			EnableMenuItem (hMenu, IDM_EDIT_COPY, MF_ENABLED) ;
		}
		EnableMenuItem (hMenu, IDM_EDIT_PASTE, IsClipboardFormatAvailable (CF_TEXT) ? MF_ENABLED : MF_GRAYED) ;
		EnableMenuItem (hMenu, IDM_VIEW_DAT, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_HKL, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_IMP, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_INS, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_SPF, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_PRF, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_PROFILE, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_STRUCTURE, MF_ENABLED) ;
		switch (pEditData->efType)
		{
		case dat :
			CheckMenuItem (hMenu, IDM_VIEW_DAT, MF_CHECKED) ;
			break ;

		case hkl :
			CheckMenuItem (hMenu, IDM_VIEW_HKL, MF_CHECKED) ;
			break ;

		case imp :
			CheckMenuItem (hMenu, IDM_VIEW_IMP, MF_CHECKED) ;
			break ;

		case ins :
			CheckMenuItem (hMenu, IDM_VIEW_INS, MF_CHECKED) ;
			break ;

		case spf :
			CheckMenuItem (hMenu, IDM_VIEW_SPF, MF_CHECKED) ;
			break ;

		case prf :
			CheckMenuItem (hMenu, IDM_VIEW_PRF, MF_CHECKED) ;
			break ;
		}
		if (!bRunEspoir)
			EnableMenuItem (hMenu, IDM_RUN_ESPOIR, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_WINDOW_CLOSEALL, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_WINDOW_CASCADE, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_WINDOW_TILE, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_WINDOW_ARRANGE, MF_ENABLED) ;
		return 0 ;

		// window is activated or deactivated
	case WM_MDIACTIVATE :
			// if the window is activated redraw the Window submenu
		if ((HWND) lParam == hwndEdit)
			SendMessage (hwndClient, WM_MDISETMENU, (WPARAM) hMenu, (LPARAM) hMenuWindow) ;
		return 0 ;

		// gains the focus
	case WM_SETFOCUS :
			// set the focus to the text window
		SetFocus (hwndText) ;
		return 0 ;

		// window size changes
	case WM_SIZE :
			// change the text window size
		MoveWindow (hwndText, 0, 0, LOWORD (lParam), HIWORD (lParam), TRUE) ;
		break ;

		// change title
	case WM_TITLE :
		strcpy (szBuffer, (pProject->pdEditWnd)[pEditData->efType].pOfn->lpstrDefExt) ;
		strcat (szBuffer, " View - ") ;
		strcat (szBuffer, pProject->szName) ;
		if (pEditData->bNeedSave)
			strcat (szBuffer, " *") ;
		SetWindowText (hwndEdit, szBuffer) ;
		return 0 ;

		// update text window
	case WM_WRITETEXT :
		SetWindowText (hwndText, (CHAR *) wParam) ;
		return 0 ;

		// commands
	case WM_COMMAND :
		if (((HWND) lParam == hwndText) && (HIWORD (wParam) == EN_UPDATE))
		{
			pEditData->bNeedSave = TRUE ;
			SendMessage (hwndEdit, WM_TITLE, 0, 0) ;
		}
		switch (LOWORD (wParam))
		{
		case IDM_FILE_SAVE :
			FileWrite (hwndText, (pProject->pdEditWnd)[pEditData->efType].pOfn) ;
			pEditData->bNeedSave = FALSE ;
			SendMessage (hwndEdit, WM_TITLE, 0, 0) ;
			return 0 ;

		case IDM_FILE_SAVEAS :
			strcpy (szBuffer, (pProject->pdEditWnd)[pEditData->efType].pOfn->lpstrFile) ;
			if (FileSaveDlg ((pProject->pdEditWnd)[pEditData->efType].pOfn))
			{
				if (strcmp (szBuffer,(pProject->pdEditWnd)[pEditData->efType].pOfn->lpstrFile))
				{
					strcpy (szBuffer, (pProject->pdEditWnd)[pEditData->efType].pOfn->lpstrFileTitle);
					szBuffer[strlen (szBuffer) - 4] = '\0' ;
					if (lstProject.exist (szBuffer))
					{
						pPTemp = lstProject.find (szBuffer) ;
						for (i = dat ; i < NBEDITFILE ; i ++)
							SendMessage ((pPTemp->pdEditWnd)[i].hwnd, WM_CLOSE, 0 , 0) ;
						SendMessage (pPTemp->hwndRunProgress, WM_CLOSE, 0, 0) ;
						SendMessage (pPTemp->hwndProfile, WM_CLOSE, 0, 0) ;
						lstProject.suppress (pPTemp) ;
					}
					strcpy (pProject->szName, szBuffer) ;
					for (i = dat ; i < NBEDITFILE ; i ++)
					{
						strcpy (szBuffer, (pProject->pdEditWnd)[pEditData->efType].pOfn->lpstrFileTitle) ;
						szBuffer[strlen (szBuffer) - 3] = '\0' ;
						strcat (szBuffer, (pProject->pdEditWnd)[i].pOfn->lpstrDefExt) ;
						strcpy ((pProject->pdEditWnd)[i].pOfn->lpstrFileTitle, szBuffer) ;
						strcpy (szBuffer, (pProject->pdEditWnd)[pEditData->efType].pOfn->lpstrFile) ;
						szBuffer[strlen (szBuffer) - 3] = '\0' ;
						strcat (szBuffer, (pProject->pdEditWnd)[i].pOfn->lpstrDefExt) ;
						strcpy ((pProject->pdEditWnd)[i].pOfn->lpstrFile, szBuffer) ;
						SendMessage ((pProject->pdEditWnd)[i].hwnd, WM_TITLE, 0, 0) ;
						SendMessage ((pProject->pdEditWnd)[i].hwnd, WM_COMMAND, (WPARAM) IDM_FILE_SAVE, 0) ;
					}
					SendMessage (pProject->hwndRunProgress, WM_TITLE, 0, 0) ;
					SendMessage (pProject->hwndProfile, WM_TITLE, 0, 0) ;
				}
				FileWrite (hwndText, (pProject->pdEditWnd)[pEditData->efType].pOfn) ;
				pEditData->bNeedSave = FALSE ;
				SendMessage (hwndEdit, WM_TITLE, 0, 0) ;
			}
			return 0 ;

		case IDM_EDIT_CUT :
			SendMessage (hwndText, WM_CUT, 0, 0) ;
			return 0 ;

		case IDM_EDIT_COPY :
			SendMessage (hwndText, WM_COPY, 0, 0) ;
			return 0 ;

		case IDM_EDIT_PASTE :
			SendMessage (hwndText, WM_PASTE, 0, 0) ;
			return 0 ;

		case IDM_VIEW_DAT :
			ViewFile (pProject, dat, hwndClient) ;
			return 0 ;

		case IDM_VIEW_HKL :
			ViewFile (pProject, hkl, hwndClient) ;
			return 0 ;

		case IDM_VIEW_IMP :
			ViewFile (pProject, imp, hwndClient) ;
			return 0 ;

		case IDM_VIEW_INS :
			ViewFile (pProject, ins, hwndClient) ;
			return 0 ;

		case IDM_VIEW_SPF :
			ViewFile (pProject, spf, hwndClient) ;
			return 0 ;

		case IDM_VIEW_PRF :
			ViewFile (pProject, prf, hwndClient) ;
			return 0 ;

		case IDM_VIEW_PROFILE :
			if (!(ViewProfile (pProject, hwndClient)))
				MessageBox (hwndEdit, "prf file does not exist !", "View Profile", MB_OK | MB_ICONERROR) ;
			return 0 ;

		case IDM_VIEW_STRUCTURE :
			ViewStructure (pProject, hwndFrame) ;
			return 0 ;

		case IDM_RUN_ESPOIR :
			if (!bRunEspoir)
			{
					// check hkl file presence
				hFile = CreateFile ((pProject->pdEditWnd)[hkl].pOfn->lpstrFile, 0, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL) ;
				CloseHandle (hFile) ;
				if (hFile == INVALID_HANDLE_VALUE)
					MessageBox (hwndEdit, "hkl file does not exist !", "Run Espoir", MB_OK | MB_ICONERROR) ;
				else
				{
					if (pProject->hwndRunProgress)
							SendMessage (pProject->hwndRunProgress, WM_CLOSE, 0, 0) ;
					CreateProgressWindow (pProject, hwndClient) ;
						// run ESPOIR
					bRunEspoir = TRUE ;
					pProject->hThread = CreateThread (NULL, 0, EspoirThread, pProject, 0, pProject->pDWThread) ;
				}
			}
			return 0 ;
		}
		break ;

		// session ends
	case WM_QUERYENDSESSION :
		
		// application ends
	case WM_CLOSE :
		if (pEditData->bNeedSave)
		{
			if (MessageBox (hwndEdit, "Save current file ?", "Close file", MB_YESNO | MB_ICONQUESTION) == IDYES)
				SendMessage (hwndEdit, WM_COMMAND, IDM_FILE_SAVE, 0) ;
		}
		break ;

		// window is being destroyed
	case WM_DESTROY :
		(pProject->pdEditWnd)[pEditData->efType].hwnd = NULL ;
		lDestroy = 0 ;
		for (i = dat ; i < NBEDITFILE ; i ++)
			lDestroy += (LONG) (pProject->pdEditWnd)[i].hwnd ;
		lDestroy += (LONG) pProject->hwndRunProgress ;
		lDestroy += (LONG) pProject->hwndProfile ;
		if (!lDestroy)
			lstProject.suppress (pProject) ;
		delete pEditData ;
		lNbChildWnd -- ;
		return 0 ;
	}
	return DefMDIChildProc (hwndEdit, message, wParam, lParam) ;
}	// EditWndProc


	// progress child window procedure
LRESULT CALLBACK ProgressWndProc (HWND hwndProgress, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND			hwndClient, hwndFrame ;		// handles to the client and frame windows
	PROJECT *		pProject ;					// pointer to the project data structure
	PROGRESSDATA *	pProgressData ;				// pointer to the progress data structure
	LONG			lDestroy ;					// project destroying flag
	LONG			i ;
	HDC				hdc ;						// handle to the device context
	PAINTSTRUCT		ps ;						// paint structure
	INT				x, y, iVertPos, iHorzPos, iPaintBeg, iPaintEnd, iOffset ;
	SCROLLINFO		si ;
	TEXTMETRIC		tm ;

		// initialize window handles
	hwndClient = GetParent (hwndProgress) ;
	hwndFrame = GetParent (hwndClient) ;

		// initialize window datas
	pProject = (PROJECT *) GetWindowLong (hwndProgress, 0) ;
	pProgressData = (PROGRESSDATA *) GetWindowLong (hwndProgress, sizeof (PROJECT *)) ;

		// process messages
	switch (message)
	{
		// progress child window creation message
	case WM_CREATE :
		lNbChildWnd ++ ;
		SetWindowLong (hwndProgress, 0, (LONG) NULL) ;
		SetWindowLong (hwndProgress, sizeof (PROJECT *), (LONG) NULL) ;
		return 0 ;

		// window datas initialization
	case WM_INITIALIZE :
		pProject = (PROJECT *) wParam ;
		SetWindowLong (hwndProgress, 0, (LONG) pProject) ;
		pProgressData = new PROGRESSDATA ;
		pProgressData->lNbLine = 0 ;
		hdc = GetDC (hwndProgress) ;
		GetTextMetrics (hdc, &tm) ;
		pProgressData->cxChar = tm.tmAveCharWidth ;
		pProgressData->cxCaps = (tm.tmPitchAndFamily & 1 ? 3 : 2) * pProgressData->cxChar / 2 ;
		pProgressData->cyChar = tm.tmHeight + tm.tmExternalLeading ;
		ReleaseDC (hwndProgress, hdc) ;
		pProgressData->iMaxWidth = 40 * pProgressData->cxChar + 22 * pProgressData->cxCaps ;
		SetWindowLong (hwndProgress, sizeof (PROJECT *), (LONG) pProgressData) ;
		return 0 ;

		// drop-down menu or submenu is about to become active
	case WM_INITMENUPOPUP :
		EnableMenuItem (hMenu, IDM_FILE_CLOSE, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_DAT, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_HKL, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_IMP, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_INS, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_SPF, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_PRF, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_PROFILE, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_STRUCTURE, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_WINDOW_CLOSEALL, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_WINDOW_CASCADE, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_WINDOW_TILE, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_WINDOW_ARRANGE, MF_ENABLED) ;
		return 0 ;

		// window is activated or deactivated
	case WM_MDIACTIVATE :
			// if the window is activated redraw the Window submenu
		if ((HWND) lParam == hwndProgress)
			SendMessage (hwndClient, WM_MDISETMENU, (WPARAM) hMenu, (LPARAM) hMenuWindow) ;
		return 0 ;

		// window size changes
	case WM_SIZE :
		if (pProgressData)
		{
			pProgressData->cxClient = LOWORD (lParam) ;
			pProgressData->cyClient = HIWORD (lParam) ;
				// set vertical scroll bar range and page size
			si.cbSize = sizeof (si) ;
			si.fMask = SIF_RANGE | SIF_PAGE ;
			si.nMin = 0 ;
			si.nMax = pProgressData->lNbLine - 1 ;
			si.nPage = pProgressData->cyClient / pProgressData->cyChar ;
			SetScrollInfo (hwndProgress, SB_VERT, &si, TRUE) ;
				// set horizontal scroll bar range and page size
			si.cbSize = sizeof (si) ;
			si.fMask = SIF_RANGE | SIF_PAGE ;
			si.nMin = 0 ;
			si.nMax = 2 + pProgressData->iMaxWidth / pProgressData->cxChar ;
			si.nPage = pProgressData->cxClient / pProgressData->cxChar ;
			SetScrollInfo (hwndProgress, SB_HORZ, &si, TRUE) ;
		}
		break ;

		// vertical scroll
	case WM_VSCROLL :
		if (pProgressData)
		{
				// get all the vertical scroll bar information
			si.cbSize = sizeof (si) ;
			si.fMask = SIF_ALL ;
			GetScrollInfo (hwndProgress, SB_VERT, &si) ;
				// save the position for comparison later on
			iVertPos = si.nPos ;
			switch (LOWORD (wParam))
			{
			case SB_TOP :
				si.nPos = si.nMin ;
				break ;

			case SB_BOTTOM :
				si.nPos = si.nMax ;
				break ;

			case SB_LINEUP :
				si.nPos -= 1 ;
				break ;

			case SB_LINEDOWN :
				si.nPos += 1 ;
				break ;

			case SB_PAGEUP :
				si.nPos -= si.nPage ;
				break ;

			case SB_PAGEDOWN :
				si.nPos += si.nPage ;
				break ;

			case SB_THUMBTRACK :
				si.nPos = si.nTrackPos ;
				break ;

			default :
				break ;         
			}
				// set the position and then retrieve it, due to adjustments by Windows it may not be the same as the value set
			si.fMask = SIF_POS ;
			SetScrollInfo (hwndProgress, SB_VERT, &si, TRUE) ;
			GetScrollInfo (hwndProgress, SB_VERT, &si) ;
				// if the position has changed, scroll the window and update it
			if (si.nPos != iVertPos)
				ScrollWindow (hwndProgress, 0, pProgressData->cyChar * (iVertPos - si.nPos), NULL, NULL) ;
		}
		return 0 ;

		// horizontal scroll
     case WM_HSCROLL :
		if (pProgressData)
		{
				// get all the horizontal scroll bar information
			si.cbSize = sizeof (si) ;
			si.fMask = SIF_ALL ;
				// save the position for comparison later on
			GetScrollInfo (hwndProgress, SB_HORZ, &si) ;
			iHorzPos = si.nPos ;
			switch (LOWORD (wParam))
			{
			case SB_LINELEFT :
				si.nPos -= 1 ;
				break ;

			case SB_LINERIGHT :
				si.nPos += 1 ;
				break ;

			case SB_PAGELEFT :
				si.nPos -= si.nPage ;
				break ;

			case SB_PAGERIGHT :
				si.nPos += si.nPage ;
				break ;

			case SB_THUMBPOSITION :
				si.nPos = si.nTrackPos ;
				break ;

			default :
				break ;
			}
				// set the position and then retrieve it, due to adjustments by Windows it may not be the same as the value set
			si.fMask = SIF_POS ;
			SetScrollInfo (hwndProgress, SB_HORZ, &si, TRUE) ;
			GetScrollInfo (hwndProgress, SB_HORZ, &si) ;
				// if the position has changed, scroll the window 
			if (si.nPos != iHorzPos)
				ScrollWindow (hwndProgress, pProgressData->cxChar * (iHorzPos - si.nPos), 0, NULL, NULL) ;
		}
		return 0 ;

		// draw the client area
	case WM_PAINT :
		hdc = BeginPaint (hwndProgress, &ps) ;
		if (pProgressData)
		{
				// set vertical scroll bar range
			si.cbSize = sizeof (si) ;
			si.fMask = SIF_RANGE | SIF_POS ;
			GetScrollInfo (hwndProgress, SB_VERT, &si) ;
			si.nMin = 0 ;
			si.nMax = pProgressData->lNbLine - 1 ;
				// save the position for comparison later on
			iVertPos = si.nPos ;
			SetScrollInfo (hwndProgress, SB_VERT, &si, TRUE) ;
			si.fMask = SIF_POS ;
			SetScrollInfo (hwndProgress, SB_VERT, &si, TRUE) ;
			GetScrollInfo (hwndProgress, SB_VERT, &si) ;
				// if the position has changed, scroll the window and update it
			ScrollWindow (hwndProgress, 0, pProgressData->cyChar * (iVertPos - si.nPos), NULL, NULL) ;
			iPaintBeg = max (0, si.nPos + ps.rcPaint.top / pProgressData->cyChar) ;
			iPaintEnd = min (si.nMax, si.nPos + ps.rcPaint.bottom / pProgressData->cyChar) ;
			iOffset = ps.rcPaint.bottom % pProgressData->cyChar ;
			for (i = iPaintBeg ; i <= iPaintEnd ; i ++)
			{
				x = pProgressData->cxChar ;
				y = pProgressData->cyChar * (i - si.nPos) + iOffset ;
				TextOut (hdc, x, y, ((pProgressData->PInfo)[i]), 120) ;
			}
		}
		EndPaint (hwndProgress, &ps) ;
		return 0 ;

	case WM_PROGRESS :
			// set vertical scroll bar range
		si.cbSize = sizeof (si) ;
		si.fMask = SIF_RANGE | SIF_POS ;
		GetScrollInfo (hwndProgress, SB_VERT, &si) ;
		si.nMin = 0 ;
		si.nMax = pProgressData->lNbLine - 1 ;
			// save the position for comparison later on
		iVertPos = si.nPos ;
		si.nPos = si.nMax ;
		SetScrollInfo (hwndProgress, SB_VERT, &si, TRUE) ;
		si.fMask = SIF_POS ;
		SetScrollInfo (hwndProgress, SB_VERT, &si, TRUE) ;
		GetScrollInfo (hwndProgress, SB_VERT, &si) ;
			// if the position has changed, scroll the window and update it
		ScrollWindow (hwndProgress, 0, pProgressData->cyChar * (iVertPos - si.nPos), NULL, NULL) ;
		return 0 ;

		// change title
	case WM_TITLE :
		strcpy (szBuffer, "Progress View - ") ;
		strcat (szBuffer, pProject->szName) ;
		SetWindowText (hwndProgress, szBuffer) ;
		return 0 ;

		// commands
	case WM_COMMAND :
		switch (LOWORD (wParam))
		{
		case IDM_VIEW_DAT :
			ViewFile (pProject, dat, hwndClient) ;
			return 0 ;

		case IDM_VIEW_HKL :
			ViewFile (pProject, hkl, hwndClient) ;
			return 0 ;

		case IDM_VIEW_IMP :
			ViewFile (pProject, imp, hwndClient) ;
			return 0 ;

		case IDM_VIEW_INS :
			ViewFile (pProject, ins, hwndClient) ;
			return 0 ;

		case IDM_VIEW_SPF :
			ViewFile (pProject, spf, hwndClient) ;
			return 0 ;

		case IDM_VIEW_PRF :
			ViewFile (pProject, prf, hwndClient) ;
			return 0 ;

		case IDM_VIEW_PROFILE :
			if (!(ViewProfile (pProject, hwndClient)))
				MessageBox (hwndProgress, "prf file does not exist !", "View Profile", MB_OK | MB_ICONERROR) ;
			return 0 ;

		case IDM_VIEW_STRUCTURE :
			ViewStructure (pProject, hwndFrame) ;
			return 0 ;
		}
		break ;

		// session ends
	case WM_QUERYENDSESSION :
		
		// application ends
	case WM_CLOSE :
		if (bRunEspoir)
		{
			if (MessageBox (hwndProgress, "Close this window will stop ESPOIR.\n Are you sure you want to close it ?", "Close file", MB_YESNO | MB_ICONQUESTION) == IDYES)
			{
				GetExitCodeThread (pProject->hThread, pProject->pDWThread) ;
				TerminateThread (pProject->hThread, * (pProject->pDWThread)) ;
				MessageBox (hwndProgress, "Run stop.", "Run Espoir", MB_OK | MB_ICONASTERISK) ;
				bRunEspoir = FALSE ;
			}
			else
				return 0 ;
		}
		break ;

		// window is being destroyed
	case WM_DESTROY :
		pProject->hwndRunProgress = NULL ;
		pProject->hThread = NULL ;
		lDestroy = 0 ;
		for (i = dat ; i < NBEDITFILE ; i ++)
			lDestroy += (LONG) (pProject->pdEditWnd)[i].hwnd ;
		lDestroy += (LONG) pProject->hwndRunProgress ;
		lDestroy += (LONG) pProject->hwndProfile ;
		if (!lDestroy)
			lstProject.suppress (pProject) ;
		delete pProgressData ;
		lNbChildWnd -- ;
		return 0 ;
	}
	return DefMDIChildProc (hwndProgress, message, wParam, lParam) ;
}	// ProgressWndProc


	// profile child window procedure
LRESULT CALLBACK ProfileWndProc (HWND hwndProfile, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND			hwndClient, hwndFrame ;				// handles to the client and frame windows
	PROJECT *		pProject ;							// pointer to the project data structure
	PROFILEDATA *	pProfileData ;						// pointer to the profile data structure
	LONG			lDestroy ;							// project destroying flag
	INT				i, j, k ;
	HDC				hdc ;								// handle to the device context
	PAINTSTRUCT		ps ;								// paint structure
	RECT			rectDC, rectPr, rectDiff, rectHKL ;	// rectangles in the client area
	HPEN			hPen ;								// handle to a pen
	DOUBLE			HPIX_STEP, VPIX_STEP ;
 	INT				x, y ;								// coordonates in client area

		// initialize window handles
	hwndClient = GetParent (hwndProfile) ;
	hwndFrame = GetParent (hwndClient) ;

		// initialize window datas
	pProject = (PROJECT *) GetWindowLong (hwndProfile, 0) ;
	pProfileData = (PROFILEDATA *) GetWindowLong (hwndProfile, sizeof (PROJECT *)) ;

		// process messages
	switch (message)
	{
		// progress child window creation message
	case WM_CREATE :
		lNbChildWnd ++ ;
		SetWindowLong (hwndProfile, 0, (LONG) NULL) ;
		SetWindowLong (hwndProfile, sizeof (PROJECT *), (LONG) NULL) ;
		return 0 ;

		// window datas initialization
	case WM_INITIALIZE :
		pProject = (PROJECT *) wParam ;
		SetWindowLong (hwndProfile, 0, (LONG) pProject) ;
		pProfileData = (PROFILEDATA *) lParam ;
		SetWindowLong (hwndProfile, sizeof (PROJECT *), (LONG) pProfileData) ;
		return 0 ;

		// drop-down menu or submenu is about to become active
	case WM_INITMENUPOPUP :
		EnableMenuItem (hMenu, IDM_FILE_CLOSE, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_DAT, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_HKL, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_IMP, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_INS, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_SPF, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_PRF, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_PROFILE, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_VIEW_STRUCTURE, MF_ENABLED) ;
		CheckMenuItem (hMenu, IDM_VIEW_PROFILE, MF_CHECKED) ;
		if (!bRunEspoir)
			EnableMenuItem (hMenu, IDM_RUN_ESPOIR, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_WINDOW_CLOSEALL, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_WINDOW_CASCADE, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_WINDOW_TILE, MF_ENABLED) ;
		EnableMenuItem (hMenu, IDM_WINDOW_ARRANGE, MF_ENABLED) ;
		return 0 ;

		// window is activated or deactivated
	case WM_MDIACTIVATE :
			// if the window is activated redraw the Window submenu
		if ((HWND) lParam == hwndProfile)
			SendMessage (hwndClient, WM_MDISETMENU, (WPARAM) hMenu, (LPARAM) hMenuWindow) ;
		return 0 ;

		// window size changes
	case WM_SIZE :
		break ;

		// draw the client area
	case WM_PAINT :
		hdc = BeginPaint (hwndProfile, &ps) ;
		if (pProfileData)
		{
			GetClientRect (hwndProfile, &rectDC) ;
			rectDC.top += 15 ;
			rectDC.bottom -= 20  ;
			rectDC.left += 20 ;
			rectDC.right -= 15 ;
			HPIX_STEP = ((DOUBLE) (rectDC.right) - (DOUBLE) (rectDC.left)) / (((pProfileData->POS)[(pProfileData->N2) - 1]) - ((pProfileData->POS)[(pProfileData->N1) - 2])) ;
			VPIX_STEP = ((DOUBLE) (rectDC.top) - (DOUBLE) (rectDC.bottom - 40)) / (DOUBLE) (pProfileData->MAX + pProfileData->MAXDIFF - pProfileData->MINDIFF) ;
			rectPr = rectDC ;
			rectPr.bottom += ((INT) (VPIX_STEP * ((DOUBLE) (pProfileData->MAXDIFF - pProfileData->MINDIFF))) - 30) ;
			hPen = CreatePen (PS_SOLID, 0, RGB (255, 0, 0)) ;
			SelectObject (hdc, hPen) ;
			MoveToEx (hdc, rectPr.left, rectPr.bottom, NULL) ;
			for (i = 1 ; i < (pProfileData->NPTS) ; i ++)
			{
				x = (INT) (HPIX_STEP * ((pProfileData->POS)[(pProfileData->N1) - 2 + i] - (pProfileData->POS)[(pProfileData->N1) - 2]) + rectPr.left) ;
				y = (INT) (rectPr.bottom + VPIX_STEP * ((DOUBLE) (pProfileData->YOBS)[i])) ;
				LineTo (hdc, x, y) ;
			}
			MoveToEx (hdc, rectPr.left, rectPr.bottom, NULL) ;
			for (i = 1 ; i < (pProfileData->NPTS) ; i ++)
			{
				x = (INT) (HPIX_STEP * ((pProfileData->POS)[(pProfileData->N1) - 2 + i] - (pProfileData->POS)[(pProfileData->N1) - 2]) + rectPr.left) ;
				y = (INT) (rectPr.bottom + VPIX_STEP * ((DOUBLE) (pProfileData->YCALC)[i])) ;
				for (j = -1 ; j != 1 ; j ++)
				{
					for (k = -1 ; k != 1 ; k ++)
						SetPixel (hdc, x + j, y + k, RGB (0, 0, 0)) ;
				}
			}
			rectHKL = rectDC ;
			rectHKL.top = rectPr.bottom + 1 ;
			rectHKL.bottom = rectHKL.top + 15 ;
			hPen = CreatePen (PS_SOLID, 0, RGB (100, 0, 255)) ;
			SelectObject (hdc, hPen) ;
			for (i = 0 ; i < (pProfileData->NHKL) ; i ++)
			{
				x = (INT) (HPIX_STEP * ((pProfileData->HKLPOS)[i] - (pProfileData->POS)[pProfileData->N1]) + rectHKL.left) ;
				MoveToEx (hdc, x, rectHKL.top, NULL) ;
				LineTo (hdc, x, rectHKL.bottom) ;
			}
			rectDiff = rectDC ;
			rectDiff.top = rectPr.bottom ;
			hPen = CreatePen (PS_SOLID, 0, RGB (255, 0, 0)) ;
			SelectObject (hdc, hPen) ;
			MoveToEx (hdc, rectDiff.left, rectDiff.bottom, NULL) ;
			for (i = 1 ; i < (pProfileData->NPTS) ; i ++)
			{
				x = (INT) (HPIX_STEP * ((pProfileData->POS)[(pProfileData->N1) - 2 + i] - (pProfileData->POS)[(pProfileData->N1) - 2]) + rectDiff.left) ;
				y = (INT) (rectDiff.bottom + VPIX_STEP * ((DOUBLE) (pProfileData->YDIFF)[i]) - VPIX_STEP * ((DOUBLE) pProfileData->MINDIFF) - 10) ;
				LineTo (hdc, x, y) ;
			}
			hPen = CreatePen (PS_SOLID, 0, RGB (0, 0, 0)) ;
			SelectObject (hdc, hPen) ;
			MoveToEx (hdc, rectDC.left, rectDC.top, NULL) ;
			LineTo (hdc, rectDC.left, rectDC.bottom) ;
			MoveToEx (hdc, rectDC.right, rectDC.top, NULL) ;
			LineTo (hdc, rectDC.right, rectDC.bottom) ;
			MoveToEx (hdc, rectDC.left, rectDC.top, NULL) ;
			LineTo (hdc, rectDC.right, rectDC.top) ;
			MoveToEx (hdc, rectDC.left, rectDC.bottom, NULL) ;
			LineTo (hdc, rectDC.right, rectDC.bottom) ;
			MoveToEx (hdc, rectDC.left, rectPr.bottom, NULL) ;
			LineTo (hdc, rectDC.right, rectPr.bottom) ;
		}
		EndPaint (hwndProfile, &ps) ;
		return 0 ;

		// change title
	case WM_TITLE :
		strcpy (szBuffer, "Profile View - ") ;
		strcat (szBuffer, pProject->szName) ;
		SetWindowText (hwndProfile, szBuffer) ;
		return 0 ;

		// commands
	case WM_COMMAND :
		switch (LOWORD (wParam))
		{
		case IDM_VIEW_DAT :
			ViewFile (pProject, dat, hwndClient) ;
			return 0 ;

		case IDM_VIEW_HKL :
			ViewFile (pProject, hkl, hwndClient) ;
			return 0 ;

		case IDM_VIEW_IMP :
			ViewFile (pProject, imp, hwndClient) ;
			return 0 ;

		case IDM_VIEW_INS :
			ViewFile (pProject, ins, hwndClient) ;
			return 0 ;

		case IDM_VIEW_SPF :
			ViewFile (pProject, spf, hwndClient) ;
			return 0 ;

		case IDM_VIEW_PRF :
			ViewFile (pProject, prf, hwndClient) ;
			return 0 ;

		case IDM_VIEW_STRUCTURE :
			ViewStructure (pProject, hwndFrame) ;
			return 0 ;
		}
		break ;

		// session ends
	case WM_QUERYENDSESSION :
		
		// application ends
	case WM_CLOSE :
		break ;

		// window is being destroyed
	case WM_DESTROY :
		pProject->hwndProfile = NULL ;
		lDestroy = 0 ;
		for (i = dat ; i < NBEDITFILE ; i ++)
			lDestroy += (LONG) (pProject->pdEditWnd)[i].hwnd ;
		lDestroy += (LONG) pProject->hwndRunProgress ;
		lDestroy += (LONG) pProject->hwndProfile ;
		if (!lDestroy)
			lstProject.suppress (pProject) ;
		delete [] pProfileData->YOBS ;
		delete [] pProfileData->YCALC ;
		delete [] pProfileData->YDIFF ;
		delete [] pProfileData->POS ;
		delete [] pProfileData->HKL ;
		delete [] pProfileData->HKLPOS ;
		delete pProfileData ;
		lNbChildWnd -- ;
		return 0 ;
	}
	return DefMDIChildProc (hwndProfile, message, wParam, lParam) ;
}	// ProfileWndProc


	// windows classes creation function
BOOL WindowClassCreation (HINSTANCE hInstance)
{
	WNDCLASS	wndclass ;		// window class

		// define the frame window class
	wndclass.style = CS_HREDRAW | CS_VREDRAW ;
	wndclass.lpfnWndProc = FrameWndProc ;
	wndclass.cbClsExtra = 0 ;
	wndclass.cbWndExtra = 0 ;
	wndclass.hInstance = hInstance ;
	wndclass.hIcon = LoadIcon (hInstance, MAKEINTRESOURCE (IDI_ICON_ESPOIR)) ;
	wndclass.hCursor = LoadCursor (NULL, IDC_ARROW) ;
	wndclass.hbrBackground = (HBRUSH) GetStockObject (BLACK_BRUSH) ;
	wndclass.lpszMenuName = szMenuName ;
	wndclass.lpszClassName = szFrameWCN ;

		// register the frame window class
	if (!RegisterClass (&wndclass))
	{
		MessageBox (NULL, "Frame window class register error !", "Espoir Error", MB_OK | MB_ICONERROR) ;
		return FALSE ;
	}

		// define the edit window class
	wndclass.lpfnWndProc = EditWndProc ;
	wndclass.cbWndExtra = sizeof (PROJECT *) + sizeof (EDITDATA *) ;
	wndclass.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH) ;
	wndclass.lpszClassName = szEditWCN ;

		// register the edit window class
	if (!RegisterClass (&wndclass))
	{
		MessageBox (NULL, "Edit window class register error !", "Espoir Error", MB_OK | MB_ICONERROR) ;
		return FALSE ;
	}

		// define the progress window class
	wndclass.lpfnWndProc = ProgressWndProc ;
	wndclass.cbWndExtra = sizeof (PROJECT *) + sizeof (PROGRESSDATA *) ;
	wndclass.lpszClassName = szProgressWCN ;

		// register the progress window class
	if (!RegisterClass (&wndclass))
	{
		MessageBox (NULL, "Progress window class register error !", "Espoir Error", MB_OK | MB_ICONERROR) ;
		return FALSE ;
	}

		// define the profile window class
	wndclass.lpfnWndProc = ProfileWndProc ;
	wndclass.cbWndExtra = sizeof (PROJECT *) + sizeof (PROFILEDATA *) ;
	wndclass.lpszClassName = szProfileWCN ;

		// register the profile window class
	if (!RegisterClass (&wndclass))
	{
		MessageBox (NULL, "Profile window class register error !", "Espoir Error", MB_OK | MB_ICONERROR) ;
		return FALSE ;
	}

	return TRUE ;
}	// WindowClassCreation


	// edit child window creation
void CreateEditWindow (PROJECT * pProject, EDITFILE ef, HWND hwndClient)
{
	HWND				hwndChild ;		// handle to child window
	MDICREATESTRUCT		mdicreate ;		// child window creation informations
	EDITDATA *			pEditData ;		// edit window informations

	pEditData = new EDITDATA ;
	pEditData->efType = ef ;
	pEditData->bNeedSave = FALSE ;
		// create an edit child window
	mdicreate.szClass = szEditWCN ;
	strcpy (szBuffer, (pProject->pdEditWnd)[ef].pOfn->lpstrDefExt) ;
	strcat (szBuffer, " View - ") ;
	strcat (szBuffer, pProject->szName) ;
	mdicreate.szTitle = szBuffer ;
	mdicreate.hOwner = hInst ;
	mdicreate.x = CW_USEDEFAULT ;
	mdicreate.y = CW_USEDEFAULT ;
	mdicreate.cx = CW_USEDEFAULT ;
	mdicreate.cy = CW_USEDEFAULT ;
	mdicreate.style = 0 ;
	mdicreate.lParam = 0 ;
	hwndChild = (HWND) SendMessage (hwndClient, WM_MDICREATE, 0, (LPARAM) (LPMDICREATESTRUCT) &mdicreate) ;
	(pProject->pdEditWnd)[ef].hwnd = hwndChild ;
	SendMessage (hwndChild, WM_INITIALIZE, (WPARAM) pProject, (LPARAM) pEditData) ;
	FileRead (WM_WRITETEXT, hwndChild, (pProject->pdEditWnd)[ef].pOfn) ;
}	// CreateEditWindow


	// progress child window creation
void CreateProgressWindow (PROJECT * pProject, HWND hwndClient)
{
	HWND				hwndChild ;		// handle to child window
	MDICREATESTRUCT		mdicreate ;		// child window creation informations

		// create a progress child window
	mdicreate.szClass = szProgressWCN ;
	strcpy (szBuffer, "Progress View - ") ;
	strcat (szBuffer, pProject->szName) ;
	mdicreate.szTitle = szBuffer ;
	mdicreate.hOwner = hInst ;
	mdicreate.x = CW_USEDEFAULT ;
	mdicreate.y = CW_USEDEFAULT ;
	mdicreate.cx = CW_USEDEFAULT ;
	mdicreate.cy = CW_USEDEFAULT ;
	mdicreate.style = WS_HSCROLL | WS_VSCROLL ; ;
	mdicreate.lParam = 0 ;
	hwndChild = (HWND) SendMessage (hwndClient, WM_MDICREATE, 0, (LPARAM) (LPMDICREATESTRUCT) &mdicreate) ;
	pProject->hwndRunProgress = hwndChild ;
	SendMessage (hwndChild, WM_INITIALIZE, (WPARAM) pProject, 0) ;
}	// CreateProgressWindow


	// profile child window creation
BOOL CreateProfileWindow (PROJECT * pProject, HWND hwndClient)
{
	HWND				hwndChild ;		// handle to child window
	MDICREATESTRUCT		mdicreate ;		// child window creation informations
	DWORD				dwBytesRead ;
	HANDLE				hFile ;
	INT					i, iFileLength ;
	CHAR *				szInfo ;		// profile informations
	LONG				pos ;			// position into the string
	PROFILEDATA *		pProfileData ;

		// open the prf file
	if (INVALID_HANDLE_VALUE == (hFile = CreateFile ((pProject->pdEditWnd)[prf].pOfn->lpstrFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)))
		return FALSE ;
		// get file size in bytes and allocate memory for read
	iFileLength = GetFileSize (hFile, NULL) ; 
	szInfo = new CHAR[iFileLength + 1] ;
		// read file and put terminating zero at end
	ReadFile (hFile, szInfo, iFileLength, &dwBytesRead, NULL) ;
	CloseHandle (hFile) ;
	szInfo[iFileLength] = '\0' ;
		// read profile informations
	pProfileData = new PROFILEDATA ;
	pos = 0 ;
	pos = SpaceJumping (szInfo, pos) ;
	pos = FloatReading (szInfo, pos, &(pProfileData->U)) ;
	pos = SpaceJumping (szInfo, pos) ;
	pos = FloatReading (szInfo, pos, &(pProfileData->V)) ;
	pos = SpaceJumping (szInfo, pos) ;
	pos = FloatReading (szInfo, pos, &(pProfileData->W)) ;
	pos = SpaceJumping (szInfo, pos) ;
	pos = FloatReading (szInfo, pos, &(pProfileData->STEPN)) ;
	pos = SpaceJumping (szInfo, pos) ;
	pos = IntReading (szInfo, pos, &(pProfileData->N1)) ;
	pos = SpaceJumping (szInfo, pos) ;
	pos = IntReading (szInfo, pos, &(pProfileData->N2)) ;
	pos = LineJumping (szInfo, pos) ;
	pos = LineJumping (szInfo, pos) ;
	pos = SpaceJumping (szInfo, pos) ;
	pos = NextSpaceJumping (szInfo, pos) ;
	pos = SpaceJumping (szInfo, pos) ;
	pos = NextSpaceJumping (szInfo, pos) ;
	pos = SpaceJumping (szInfo, pos) ;
	pos = FloatReading (szInfo, pos, &(pProfileData->STEP)) ;
	pos = LineJumping (szInfo, pos) ;
	pos = SpaceJumping (szInfo, pos) ;
	pos = NextSpaceJumping (szInfo, pos) ;
	pos = SpaceJumping (szInfo, pos) ;
	pos = IntReading (szInfo, pos, &(pProfileData->NPTS)) ;
	pos = LineJumping (szInfo, pos) ;
	pos = SpaceJumping (szInfo, pos) ;
	pos = IntReading (szInfo, pos, &(pProfileData->NHKL)) ;
	pos = LineJumping (szInfo, pos) ;
	pProfileData->YOBS = new INT [pProfileData->NPTS] ;
	pos = IntArrayReading (szInfo, pos, pProfileData->YOBS, pProfileData->NPTS) ;
	pos = LineJumping (szInfo, pos) ;
	pProfileData->YCALC = new INT [pProfileData->NPTS] ;
	pos = IntArrayReading (szInfo, pos, pProfileData->YCALC, pProfileData->NPTS) ;
	pProfileData->YDIFF = new INT [pProfileData->NPTS] ;
	pProfileData->HKL = new LONG [pProfileData->NHKL] ;
	pos = LongArrayReading (szInfo, pos, pProfileData->HKL, pProfileData->NHKL) ;
	pProfileData->HKLPOS = new DOUBLE [pProfileData->NHKL] ;
	pos = FloatArrayReading (szInfo, pos, pProfileData->HKLPOS, pProfileData->NHKL) ;
	for (i = 0 ; i < pProfileData->NPTS ; i ++)
		(pProfileData->YDIFF)[i] = (pProfileData->YOBS)[i] - (pProfileData->YCALC)[i] ;
	pProfileData->MAX = MaxInArray (pProfileData->YOBS, pProfileData->NPTS) ;
	if (pProfileData->MAX < MaxInArray (pProfileData->YCALC, pProfileData->NPTS))
		pProfileData->MAX = MaxInArray (pProfileData->YCALC, pProfileData->NPTS) ;
	pProfileData->MAXDIFF = MaxInArray (pProfileData->YDIFF, pProfileData->NPTS) ;
	pProfileData->MINDIFF = MinInArray (pProfileData->YDIFF, pProfileData->NPTS) ;
	pProfileData->POS = new DOUBLE [pProfileData->N2] ;
	PosCalc (pProfileData) ;
	free (szInfo) ;
		// create a profile child window
	mdicreate.szClass = szProfileWCN ;
	strcpy (szBuffer, "Profile View - ") ;
	strcat (szBuffer, pProject->szName) ;
	mdicreate.szTitle = szBuffer ;
	mdicreate.hOwner = hInst ;
	mdicreate.x = CW_USEDEFAULT ;
	mdicreate.y = CW_USEDEFAULT ;
	mdicreate.cx = CW_USEDEFAULT ;
	mdicreate.cy = CW_USEDEFAULT ;
	mdicreate.style = 0 ;
	mdicreate.lParam = 0 ;
	hwndChild = (HWND) SendMessage (hwndClient, WM_MDICREATE, 0, (LPARAM) (LPMDICREATESTRUCT) &mdicreate) ;
	pProject->hwndProfile = hwndChild ;
	SendMessage (hwndChild, WM_INITIALIZE, (WPARAM) pProject, (LPARAM) pProfileData) ;
	SendMessage (hwndChild, WM_PAINT, 0, 0) ;
	return TRUE ;
}	// CreateProfileWindow


	// view edit file
void ViewFile (PROJECT * pProject, EDITFILE ef, HWND hwndClient)
{
	if ((pProject->pdEditWnd)[ef].hwnd)
		SendMessage (hwndClient, WM_MDIACTIVATE, (WPARAM) (pProject->pdEditWnd)[ef].hwnd, 0) ;
	else
		CreateEditWindow (pProject, ef, hwndClient) ;
}	// ViewFile


	// view profile
BOOL ViewProfile (PROJECT * pProject, HWND hwndClient)
{
	if (pProject->hwndProfile)
	{
		SendMessage (hwndClient, WM_MDIACTIVATE, (WPARAM) pProject->hwndProfile, 0) ;
		return TRUE ;
	}
	else
		return (CreateProfileWindow (pProject, hwndClient)) ;
}	// ViewProfile


	// view structure (run RasMol)
void ViewStructure (PROJECT * pProject, HWND hwndFrame)
{
	OPENFILENAME *		pOfnStructure ;
	CHAR				szDir[BUFFER_SIZE] ;
	CHAR *				szFile ;

	pOfnStructure = new OPENFILENAME ;
	FileInitialize (hwndFrame, pOfnStructure, ".xyz Files (*.xyz)\0*.xyz\0All Files (*.*)\0*.*\0\0", "xyz") ;
	strcpy (szBuffer, (pProject->pdEditWnd)[dat].pOfn->lpstrFileTitle) ;
	szBuffer[strlen (szBuffer) - 3] = '\0' ;
	strcat (szBuffer, pOfnStructure->lpstrDefExt) ;
	strcpy (pOfnStructure->lpstrFileTitle, szBuffer) ;
	strcpy (szBuffer, (pProject->pdEditWnd)[dat].pOfn->lpstrFile) ;
	szBuffer[strlen (szBuffer) - 3] = '\0' ;
	strcat (szBuffer, pOfnStructure->lpstrDefExt) ;
	strcpy (pOfnStructure->lpstrFile, szBuffer) ;
	if (FileOpenDlg (pOfnStructure))
	{
			// set current directory
		strcpy (szDir, (pProject->pdEditWnd)[dat].pOfn->lpstrFile) ;
		szFile = strstr (szDir, (pProject->pdEditWnd)[dat].pOfn->lpstrFileTitle) ;
		szFile[0] = '\0' ;
		SetCurrentDirectory (szDir) ;
			// run RasMol
		strcpy (szBuffer, "RasMol.exe -xyz ") ;
		strcat (szBuffer, pOfnStructure->lpstrFileTitle) ;
		WinExec (szBuffer, SW_SHOWNORMAL) ;
	}
	delete [] pOfnStructure->lpstrFile ;
	delete [] pOfnStructure->lpstrFileTitle ;
	delete pOfnStructure;
}	// ViewStructure


	// ESPOIR thread
DWORD WINAPI EspoirThread (void * pvoid)
{
	PROJECT *	pProject ;
	CHAR		szDir[BUFFER_SIZE] ;
	CHAR *		szFile ;

	pProject = (PROJECT *) pvoid ;
		// set current directory
	strcpy (szDir, (pProject->pdEditWnd)[dat].pOfn->lpstrFile) ;
	szFile = strstr (szDir, (pProject->pdEditWnd)[dat].pOfn->lpstrFileTitle) ;
	szFile[0] = '\0' ;
	SetCurrentDirectory (szDir) ;
	ESPOIR (pProject, pProject->szName, (LONG) strlen (pProject->szName)) ;
	bRunEspoir = FALSE ;
	MessageBox (pProject->hwndRunProgress, "Run terminate.", "Run Espoir", MB_OK | MB_ICONASTERISK) ;
	GetExitCodeThread (pProject->hThread, pProject->pDWThread) ;
	ExitThread (* (pProject->pDWThread)) ;
	return 0 ;
}	// EspoirThread


	// update run progress view
void WINAPI PROGRESSVIEW (PROJECT * pProject, CHAR * szText, LONG lLenght)
{
	PROGRESSDATA *		pProgressData ;		// pointer to the progress window data structure

	pProgressData = (PROGRESSDATA *) GetWindowLong (pProject->hwndRunProgress, sizeof (PROJECT *)) ;
	szText[lLenght] = '\0' ;
	strcpy ((pProgressData->PInfo)[pProgressData->lNbLine ++], szText) ;
	SendMessage (pProject->hwndRunProgress, WM_PROGRESS, 0, 0) ;
}	// PROGRESSVIEW
