/********************************************************************
*																	*
*		File :		ESPTYPES.H										*
*		Type :		header											*
*		Version :	1.0												*
*		Date :		24/07/2000										*
*		Author :	Marc MILEUR										*
*																	*
********************************************************************/


	// new types

	// edit file types
typedef enum
{
	dat,
	hkl,
	imp,
	ins,
	spf,
	prf
}
EDITFILE ;

#define		NBEDITFILE	6	// number of edit file types

	// espoir projects informations
typedef struct
{
	HWND			hwnd ;
	OPENFILENAME *	pOfn ;
}
PROJECTDATA ;

typedef struct
{
	CHAR *			szName ;
	PROJECTDATA		pdEditWnd[NBEDITFILE] ;
	HWND			hwndRunProgress, hwndProfile ;
	HANDLE			hThread ;
	DWORD *			pDWThread ;
}
PROJECT ;

	// edit child windows informations
typedef struct
{
	EDITFILE	efType ;
	BOOL		bNeedSave ;
}
EDITDATA ;

#define		LINE_SIZE	121		// line size

	// run espoir progress informations
class PROGRESSINFO
{
public :
	PROGRESSINFO () ;
	~PROGRESSINFO () ;
	PROGRESSINFO (const PROGRESSINFO &) ;
	PROGRESSINFO & operator= (const PROGRESSINFO &) ;
	CHAR * operator[] (LONG) const ;
	CHAR * & operator[] (LONG) ;
private :
	CHAR *			_szLine ;
	PROGRESSINFO *	_next ;
} ;

typedef struct
{
	INT				cxChar, cxCaps, cyChar, cxClient, cyClient, iMaxWidth ;		
	LONG			lNbLine ;
	PROGRESSINFO	PInfo ;	
}
PROGRESSDATA ;

	// profile informations
typedef struct
{
	DOUBLE		U, V, W, STEPN, STEP ;
	INT			N1, N2, NPTS, NHKL ;
	INT	*		YOBS ;
	INT *		YCALC ;
	INT			MAX, MAXDIFF, MINDIFF ;
	INT *		YDIFF ;
	DOUBLE *	POS ;
	LONG *		HKL ;
	DOUBLE *	HKLPOS ;
}
PROFILEDATA ;

	// PRJCELL class declaration
class PRJCELL ;


	// PRJLIST class declaration
class PRJLIST
{
public :
	PRJLIST () ;
	~PRJLIST () ;
	void insert (PROJECT *) ;
	void suppress (PROJECT *) ;
	BOOL exist (CHAR *) ;
	PROJECT * find (CHAR *) ;
private :
	PRJCELL * _first ;
} ;	// PRJLIST


class PRJCELL
{
	private :
		friend class PRJLIST ;
		PRJCELL (PROJECT * = NULL, PRJCELL * = NULL) ;
		~PRJCELL () ;
		PROJECT * _pProject ;
		PRJCELL * _next ;
} ;	// PRJCELL


	// functions declarations
extern "C" {	// for FORTRAN compatibility
	void ProjectInitialize (PROJECT *, HWND) ;
	void ProjectDestroy (PROJECT *) ;
}
