/********************************************************************
*																	*
*		File :		FILE.CPP										*
*		Type :		source											*
*		Version :	1.0												*
*		Date :		24/07/2000										*
*		Author :	Marc MILEUR										*
*																	*
********************************************************************/


#include "espoir.h"


	// functions

	// OPENFILENAME structure initialization
void FileInitialize (HWND hwnd, OPENFILENAME * pOfn, CHAR * szFilter, CHAR * szExt)
{
	CHAR		* szFileName, * szTitleName ;

	szFileName = new CHAR [MAX_PATH] ;
	szFileName[0] = '\0' ;
	szTitleName = new CHAR [MAX_PATH] ;
	szTitleName[0] = '\0' ;
	pOfn->lStructSize		= sizeof (OPENFILENAME) ;
	pOfn->hwndOwner			= hwnd ;
	pOfn->hInstance			= NULL ;
	pOfn->lpstrFilter		= szFilter ;
	pOfn->lpstrCustomFilter	= NULL ;
	pOfn->nMaxCustFilter	= 0 ;
	pOfn->nFilterIndex		= 0 ;
	pOfn->lpstrFile			= szFileName ;
	pOfn->nMaxFile			= MAX_PATH ;
	pOfn->lpstrFileTitle	= szTitleName ;
	pOfn->nMaxFileTitle		= MAX_PATH ;
	pOfn->lpstrInitialDir	= NULL ;
	pOfn->lpstrTitle		= NULL ;
	pOfn->Flags				= 0 ;
	pOfn->nFileOffset		= 0 ;
	pOfn->nFileExtension	= 0 ;
	pOfn->lpstrDefExt		= szExt ;
	pOfn->lCustData			= 0L ;
	pOfn->lpfnHook			= NULL ;
	pOfn->lpTemplateName	= NULL ;
}	// FileInitialize


	// open file
BOOL FileOpenDlg (OPENFILENAME * pOfn)
{
	pOfn->Flags = OFN_HIDEREADONLY | OFN_CREATEPROMPT ;
	return (GetOpenFileName (pOfn)) ;
}	// FileOpenDlg


	// read file
BOOL FileRead (UINT message, HWND hwnd, OPENFILENAME * pOfn)
{
	DWORD		dwBytesRead ;
	HANDLE		hFile ;
	INT			iFileLength ;
	CHAR *		szBuffer ;

		// open the file
	if (INVALID_HANDLE_VALUE == (hFile = CreateFile (pOfn->lpstrFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)))
		return FALSE ;
		// get file size in bytes and allocate memory for read
	iFileLength = GetFileSize (hFile, NULL) ; 
	szBuffer = new CHAR[iFileLength + 1] ;
		// read file and put terminating zero at end
	ReadFile (hFile, szBuffer, iFileLength, &dwBytesRead, NULL) ;
	CloseHandle (hFile) ;
	szBuffer[iFileLength] = '\0' ;
		// display text
	SendMessage (hwnd, message, (WPARAM) szBuffer, 0) ;
	free (szBuffer) ;
	return TRUE ;
}	// FileRead


	// write file
BOOL FileWrite (HWND hwndText, OPENFILENAME * pOfn)
{
	DWORD		dwBytesWritten ;
	HANDLE		hFile ;
	INT			iLength ;
	CHAR *		szBuffer ;
	WORD		wByteOrderMark = 0xFEFF ;

		// open the file, creating it if necessary
	if (INVALID_HANDLE_VALUE == (hFile = CreateFile (pOfn->lpstrFile, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, NULL)))
		return FALSE ;
		// get the number of characters in the edit control and allocate memory for them
	iLength = GetWindowTextLength (hwndText) ;
	szBuffer = new CHAR[iLength + 1] ;
		// get the edit buffer and write that out to the file
	GetWindowText (hwndText, szBuffer, iLength + 1) ;
	WriteFile (hFile, szBuffer, iLength * sizeof (CHAR), &dwBytesWritten, NULL) ;
	CloseHandle (hFile) ;
	delete [] szBuffer ;
	return ((iLength * sizeof (CHAR)) == (INT) dwBytesWritten) ;
}	// FileWrite


	// save file
BOOL FileSaveDlg (OPENFILENAME * pOfn)
{
	pOfn->Flags	= OFN_OVERWRITEPROMPT ;
	return (GetSaveFileName (pOfn)) ;
}	// FileSaveDlg


