/********************************************************************
*																	*
*		File :		STRING.CPP										*
*		Type :		source											*
*		Version :	1.0												*
*		Date :		24/07/2000										*
*		Author :	Marc MILEUR										*
*																	*
********************************************************************/


#include "espoir.h"


LONG SpaceJumping (CHAR * szBuffer, LONG pos)
{
	while (szBuffer[pos] == ' ')
	{
		pos ++ ;
	}
	return pos ;
}	// SpaceJumping


LONG FloatReading (CHAR * szBuffer, LONG pos, DOUBLE * f)
{
	BOOL	minus = FALSE;
	LONG	factor = 10 ;

	if (szBuffer[pos] == '-')
	{
		minus = TRUE ;
		pos ++ ;
	}
	*f = 0 ;
	while (szBuffer[pos] != '.')
	{
		*f = 10 * (*f) + szBuffer[pos ++] - '0' ;
	}
	pos ++ ;
	while ((szBuffer[pos] >= '0') && (szBuffer[pos] <= '9'))
	{
		(*f) += (DOUBLE) (szBuffer[pos ++] - '0') / (DOUBLE) factor ;
		factor = 10 * factor ;
	}
	if (minus)
		(*f) = - (*f) ;
	return pos ;
}	// FloatReading


LONG IntReading (CHAR *szBuffer, LONG pos, INT * i)
{
	BOOL	minus = FALSE;

	if (szBuffer[pos] == '-')
	{
		minus = TRUE ;
		pos ++ ;
	}
	*i = 0 ;
	while ((szBuffer[pos] >= '0') && (szBuffer[pos] <= '9'))
	{
		*i = 10 * (*i) + szBuffer[pos ++] - '0' ;
	}
	return pos ;
}	// IntReading


LONG LineJumping (CHAR * szBuffer, LONG pos)
{
	while (szBuffer[pos] != 13)
	{
		pos ++ ;
	}
	pos ++ ;
	pos ++ ;
	return pos ;
}	// LineJumping


LONG NextSpaceJumping (CHAR * szBuffer, LONG pos)
{
	while (szBuffer[pos] != ' ')
	{
		pos ++ ;
	}
	return pos ;
}	// NextSpaceJumping


LONG IntArrayReading (CHAR * szBuffer, LONG pos, INT * array, INT iArrayLength)
{
	for (INT i = 0 ; i < iArrayLength ; i ++)
	{
		pos = NextNumberJumping (szBuffer, pos) ;
		pos = IntReading (szBuffer, pos, &(array[i])) ;
	}
	return pos ;
}	// IntArrayReading


LONG NextNumberJumping (CHAR * szBuffer, LONG pos)
{
	while ((szBuffer[pos] < '0') || (szBuffer[pos] > '9'))
	{
		pos ++ ;
	}
	return pos ;
}	// NextNumberJumping


LONG LongArrayReading (CHAR * szBuffer, LONG pos, LONG * array, INT iArrayLength)
{
	for (INT i = 0 ; i < iArrayLength ; i ++)
	{
		pos = NextNumberJumping (szBuffer, pos) ;
		pos = LongReading (szBuffer, pos, &(array[i])) ;
	}
	return pos ;
}	// LongArrayReading


LONG LongReading (CHAR *szBuffer, LONG pos, LONG * l)
{
	BOOL	minus = FALSE;

	if (szBuffer[pos] == '-')
	{
		minus = TRUE ;
		pos ++ ;
	}
	*l = 0 ;
	while ((szBuffer[pos] >= '0') && (szBuffer[pos] <= '9'))
	{
		*l = 10 * (*l) + szBuffer[pos ++] - '0' ;
	}
	return pos ;
}	// LongReading


LONG FloatArrayReading (CHAR * szBuffer, LONG pos, DOUBLE * array, INT iArrayLength)
{
	for (INT i = 0 ; i < iArrayLength ; i ++)
	{
		pos = NextNumberJumping (szBuffer, pos) ;
		pos = FloatReading (szBuffer, pos, &(array[i])) ;
	}
	return pos ;
}	// FloatArrayReading
